# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

# rubocop:disable RSpec/MessageSpies
module LetItCrash
  RSpec.describe Matcher do
    include_context 'with_branch_and_sha'
    let(:environment) { { 'CF_BRANCH' => branch, 'CF_REVISION' => sha } }

    context 'when Codefresh matches' do
      it { expect(matcher.matches?).to be_truthy }
      it { expect(matcher.branch).to eq branch }
      it { expect(matcher.sha).to eq sha }
    end # context 'when Codefresh matches'

    context 'when nothing matches' do
      let(:branch) { nil }

      before do
        expect(IO)
          .to receive(:popen)
          .with(Matchers::Git::STATUS_CMD)
          .and_return(instance_double(IO, read: 'fatal'))
      end

      it { expect(matcher.matches?).to be_falsey }
    end # context 'when nothing matches'
  end # RSpec.describe Matcher
end # module LetItCrash
