# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe CircleCI do
      include_context 'with_branch_and_sha'
      let(:ci)        { 'true' }
      let(:circle_ci) { 'true' }
      let(:environment) do
        {
          'CI' => ci,
          'CIRCLECI' => circle_ci,
          'CIRCLE_BRANCH' => branch,
          'CIRCLE_SHA1' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with CI and CIRCLECI set to `true` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with CI and CIRCLECI set to `true` (default)'

        context 'with CI set to nil' do
          let(:ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CI set to nil'

        context 'with CIRCLECI set to nil' do
          let(:circle_ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CIRCLECI set to nil'
      end # describe '#matches?'
    end # RSpec.describe CircleCI
  end # module Matchers
end # module LetItCrash
