# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe Codefresh do
      include_context 'with_branch_and_sha'
      let(:environment) do
        {
          'CF_BRANCH' => branch,
          'CF_REVISION' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'when CF_BRANCH set (default)' do
          it { expect(result).to be_truthy }
        end # context 'when CF_BRANCH set (default)'

        context 'when CF_BRANCH not set' do
          let(:branch) { nil }

          it { expect(result).to be_falsey }
        end # context 'when CF_BRANCH not set'
      end # describe '#matches?'
    end # RSpec.describe Codefresh
  end # module Matchers
end # module LetItCrash
