# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe Codeship do
      include_context 'with_branch_and_sha'
      let(:ci)        { 'true' }
      let(:ci_name)   { 'codeship' }
      let(:environment) do
        {
          'CI' => ci,
          'CI_NAME' => ci_name,
          'CI_BRANCH' => branch,
          'CI_COMMIT_ID' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with CI and CI_NAME set to `codeship` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with CI and CI_NAME set to `codeship` (default)'

        context 'with CI set to nil' do
          let(:ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CI set to nil'

        context 'with CI_NAME set to nil' do
          let(:ci_name) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CI_NAME set to nil'
      end # describe '#matches?'
    end # RSpec.describe Codeship
  end # module Matchers
end # module LetItCrash
