# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe Jenkins do
      include_context 'with_branch_and_sha'
      let(:jenkins_url) { 'true' }
      let(:environment) do
        {
          'JENKINS_URL' => jenkins_url,
          'GIT_BRANCH' => branch,
          'GIT_COMMIT' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with JENKINS_URL set to `true` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with JENKINS_URL set to `true` (default)'

        context 'with JENKINS_URL set to nil' do
          let(:jenkins_url) { nil }

          it { expect(result).to be_falsey }
        end # context 'with JENKINS_URL set to nil'
      end # describe '#matches?'
    end # RSpec.describe Jenkins
  end # module Matchers
end # module LetItCrash
