# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe Semaphore do
      include_context 'with_branch_and_sha'
      let(:ci)        { 'true' }
      let(:semaphore) { 'true' }
      let(:environment) do
        {
          'CI' => ci,
          'SEMAPHORE' => semaphore,
          'BRANCH_NAME' => branch,
          'REVISION' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with CI and SEMAPHORE set to `true` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with CI and SEMAPHORE set to `true` (default)'

        context 'with CI set to nil' do
          let(:ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CI set to nil'

        context 'with SEMAPHORE set to nil' do
          let(:semaphore) { nil }

          it { expect(result).to be_falsey }
        end # context 'with SEMAPHORE set to nil'
      end # describe '#matches?'
    end # RSpec.describe Semaphore
  end # module Matchers
end # module LetItCrash
