# frozen_string_literal: true

require 'spec_helper'
require 'matchers/shared_helpers'

module LetItCrash
  module Matchers
    RSpec.describe TravisCI do
      include_context 'with_branch_and_sha'
      let(:ci)        { 'true' }
      let(:travis)    { 'true' }
      let(:environment) do
        {
          'CI' => ci,
          'TRAVIS' => travis,
          'TRAVIS_BRANCH' => branch,
          'TRAVIS_COMMIT' => sha
        }
      end

      it_behaves_like 'reports_branch_and_sha'

      describe '#matches?' do
        let(:result) { matcher.matches? }

        context 'with CI and TRAVIS set to `true` (default)' do
          it { expect(result).to be_truthy }
        end # context 'with CI and TRAVIS set to `true` (default)'

        context 'with CI set to nil' do
          let(:ci) { nil }

          it { expect(result).to be_falsey }
        end # context 'with CI set to nil'

        context 'with TRAVIS set to nil' do
          let(:travis) { nil }

          it { expect(result).to be_falsey }
        end # context 'with TRAVIS set to nil'
      end # describe '#matches?'
    end # RSpec.describe TravisCI
  end # module Matchers
end # module LetItCrash
